﻿using System;

namespace jelado
{
  class Jel
  {
    public int Ora { get; set; }
    public int Perc { get; set; }
    public int Mp { get; set; }
    public int Ido { get; }
    public int X { get; set; }
    public int Y { get; set; }
    public Jel(string[] sor)
    {
      Ora = int.Parse(sor[0]);
      Perc = int.Parse(sor[1]);
      Mp = int.Parse(sor[2]);
      X = int.Parse(sor[3]);
      Y = int.Parse(sor[4]);
      Ido = Ora * 3600 + Perc * 60 + Mp;
    }
  }
  class Program
  {
    static void Main(string[] args)
    {
      //1. feladat;
      Jel[] jelek = Beolvasas("jel.txt");
      Console.WriteLine("2. feladat");
      Console.Write("\tAdja meg a jel sorszámát! ");
      int adatsor = int.Parse(Console.ReadLine());
      Console.WriteLine($"\tx = {jelek[adatsor-1].X}\ty = {jelek[adatsor - 1].Y}");
      //3. feladat;
      Console.WriteLine("\n4. feladat");
      Console.WriteLine("\tIdőtartam: " + IdoString(Eltelt(jelek[0],jelek[jelek.Length - 1]),':') );
      Console.WriteLine();
      Console.WriteLine("\n5. feladat");
      Terulet(jelek);
      Console.WriteLine("\n6. feladat");
      Console.WriteLine("\tElmozdulás: {0:F3} egység", Elmozdulas(jelek));
      //7. feladat
      Kiiras(jelek, "kimaradt.txt");
    }

    private static void Kiiras(Jel[] jelek, string fajlnev)
    {
      using (System.IO.StreamWriter sw = new(fajlnev))
      {
        for (int i = 1; i < jelek.Length; i++)
        {
          int hiba = Hiba(jelek, i);
          if (hiba != 0)
          {
            sw.Write(IdoString(jelek[i].Ido, ' '));
            if (hiba % 2 == 0) sw.WriteLine(" időeltérés {0}", hiba / 2);
            else sw.WriteLine(" koordináta-eltérés {0}", (hiba - 1) / 2);
          }
        }
      }//a using miatt be is zárja.
    }

    private static int Hiba(Jel[] jelek, int adat)
    {
      int mozog = Mozgott(jelek, adat);
      int idohiba = (Eltelt(jelek[adat - 1], jelek[adat]) - 1) / (5 * 60);
      int helyhiba = (mozog - 1) / 10;
      if (idohiba + helyhiba == 0)
        return 0;
      return (idohiba > helyhiba) ? (idohiba * 2) : (helyhiba * 2 + 1);
    }

    private static int Mozgott(Jel[] jelek, int adat)
    {
      return Math.Max(Math.Abs(jelek[adat].X - jelek[adat - 1].X), Math.Abs(jelek[adat].Y - jelek[adat - 1].Y));
    }

    private static double Elmozdulas(Jel[] jelek)
    {
      double sum = 0;
      for (int i = 1; i < jelek.Length; i++)
      {
        int dx = jelek[i].X - jelek[i - 1].X;
        int dy = jelek[i].Y - jelek[i - 1].Y;
        sum += Math.Sqrt(dx*dx + dy*dy);
      } 
      return sum;
    }

    private static void Terulet(Jel[] jelek)
    {
      int minX = jelek[0].X;
      int maxX = jelek[0].X;
      int minY = jelek[0].Y;
      int maxY = jelek[0].Y;

      for (int i = 1; i < jelek.Length; i++)
      {
        if (minX > jelek[i].X) minX = jelek[i].X;
        if (minY > jelek[i].Y) minY = jelek[i].Y;
        if (maxX < jelek[i].X) maxX = jelek[i].X;
        if (maxY < jelek[i].Y) maxY = jelek[i].Y;
      }
      Console.WriteLine($"\tBal alsó: {minX} {minY}, jobb felső: {maxX} {maxY}");
    }

    private static string IdoString(int ido, char sep)
    {
      int mp = ido % 60;
      int perc = (ido / 60) % 60;
      int ora = ido / 3600;
      return ora.ToString() + sep + perc.ToString() + sep + mp.ToString();
    }

    private static int Eltelt(Jel kezd, Jel veg)
    {
      return veg.Ido - kezd.Ido;
    }

    private static Jel[] Beolvasas(string fajlnev)
    {
      System.Collections.Generic.List<Jel> input = new();
      using (System.IO.StreamReader sr = new(fajlnev))
      {
        while (!sr.EndOfStream)
        {
          input.Add(new Jel(sr.ReadLine().Split(' ')));
        }
      }//a using miatt be is zárja.
      return input.ToArray();
    }
  }
}
